﻿<%@ Page Title="Home Page" Language="C#" MasterPageFile="~/Site.Master" AutoEventWireup="true" CodeBehind="Default.aspx.cs" Inherits="WebApplication21._Default" %>

<asp:Content runat="server" ID="BodyContent" ContentPlaceHolderID="MainContent">
    <ej:Grid ID="Grid" runat="server" AllowPaging="true"
        OnServerWordExporting="Grid_ServerWordExporting"
        OnServerPdfExporting="Grid_ServerPdfExporting"
        OnServerExcelExporting="Grid_ServerExcelExporting">

        <ToolbarSettings ShowToolbar="true" ToolbarItems="excelExport,wordExport,pdfExport"></ToolbarSettings>

        <DataManager Adaptor="WebApiAdaptor" URL="/api/Orders" Offline="true" />

        <Columns>
            <ej:Column Field="OrderID" HeaderText="OrderID" />
            <ej:Column Field="EmployeeID" HeaderText="Employee ID" />
            <ej:Column Field="CustomerID" HeaderText="Customer ID" />
            <ej:Column Field="Freight" HeaderText="Freight" Format="{0:C2}" />
            <ej:Column Field="ShipCountry" HeaderText="ShipCountry" />
        </Columns>
        <ClientSideEvents Load="onLoad" ToolbarClick="onToolbarClick" />
    </ej:Grid>

    <script>
        function onLoad(args) {
            this.ignoreOnExport.splice(this.ignoreOnExport.indexOf('dataSource'), 1);
        }
    </script>

    <%--    <script type="text/javascript">
        function dataBound(args) {
            var data = new ej.DataManager({
                url: "/api/Employees", adaptor: new ej.WebApiAdaptor(), offline: true
            })
            this.element.ejWaitingPopup("show");//show popup
            data.executeQuery(new ej.Query())
            .done(function (e) {
                var obj = $('#<%= Grid.ClientID %>').ejGrid('instance');
                obj.element.ejWaitingPopup("hide");//hide after loading data for dropdown
                obj.getColumnByField("EmployeeID").dataSource = e.result
            })
        }
        function create() {
            return $("<input>");
        }
        function write(args) {
            var obj = $('#<%= Grid.ClientID %>').ejGrid('instance');
            args.element.ejDropDownList({
                width: "100%",
                dataSource: ej.distinct(obj.getColumnByField("EmployeeID").dataSource, "EmployeeID"),
                value: args.rowdata !== undefined ? args.rowdata["EmployeeID"] : ""
            });
        }
        function read(args) {
            return args.ejDropDownList("getValue");
        }--%>
    </script>
</asp:Content>
