﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using Syncfusion.JavaScript;
using System.Linq;
using Syncfusion.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.Services;
using System.Web.Script.Services;
using SyncfusionMvcApplication3.Models;
using Syncfusion.JavaScript.Models;
using Syncfusion.EJ.Export;
using Syncfusion.XlsIO;
using System.Web.Script.Serialization;
using System.Reflection;
using WebApplication21.Models;
using System.Web.Http;
using Newtonsoft.Json;

namespace WebApplication21
{
    public partial class _Default : Page
    {
        IEnumerable<Order> currentData;
        NorthWndDataContext db = new NorthWndDataContext();
        protected void Page_Load(object sender, EventArgs e)
        {
           
        }
        
        protected void Grid_ServerExcelExporting(object sender, Syncfusion.JavaScript.Web.GridEventArgs e)
        {
            ExcelExport exp = new ExcelExport();
            string gridmodel = (string)e.Arguments.ToList()[0].Value;
             ConvertGridObject(gridmodel);
             exp.Export(Grid.Model, currentData, "Export.xlsx", ExcelVersion.Excel2010, true, true, "flat-lime");
        }

        protected void Grid_ServerWordExporting(object sender, Syncfusion.JavaScript.Web.GridEventArgs e)
        {
            WordExport exp = new WordExport();
            exp.Export(Grid.Model, (IEnumerable)db.Orders, "Export.docx", true, true, "flat-lime");
        }

        protected void Grid_ServerPdfExporting(object sender, Syncfusion.JavaScript.Web.GridEventArgs e)
        {
            PdfExport exp = new PdfExport();
            exp.Export(Grid.Model, (IEnumerable)db.Orders, "Export.pdf", true, true, "flat-lime");
        }
        private void ConvertGridObject(string gridProperty)
        {
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            IEnumerable div = (IEnumerable)serializer.Deserialize(gridProperty, typeof(IEnumerable));
            GridProperties gridProp = new GridProperties();
            foreach (KeyValuePair<string, object> ds in div)
            {
                var property = gridProp.GetType().GetProperty(ds.Key, BindingFlags.Instance | BindingFlags.Public | BindingFlags.IgnoreCase);

                //Check and retrieve additional property here
                if (ds.Key == "dataSource")
                {
                    foreach (KeyValuePair<string, object> data in (dynamic)ds.Value)
                    {
                        if (data.Key == "dataSource") {
                            foreach (KeyValuePair<string, object> data1 in (dynamic)data.Value)
                            {
                                if (data1.Key == "json") {
                                    string serial = serializer.Serialize(data1.Value);
                                    currentData = JsonConvert.DeserializeObject<IEnumerable<Order>>(serial);
                                    break;
                                }

                            }
                        }
                    }
                    break;
                }
            }
        }
    }
}